Smart.Editor Dialogs

Editor for React

React version of this topic (compatible with React 19+). Keep the same configuration logic from JavaScript and pass it as component props.

What this topic covers: practical setup, the framework-specific API access pattern, and copy-adapt guidance for the examples in this page.

import React, { useMemo, useRef } from 'react';
import { Editor } from 'smart-webcomponents-react/editor';
import 'smart-webcomponents-react/source/styles/smart.default.css';

export default function App() {
  const componentRef = useRef(null);
  const componentProps = useMemo(() => ({
    // Copy this topic's JavaScript configuration here.
  }), []);

  return <Editor ref={componentRef} {...componentProps}></Editor>;
}

Use componentRef.current for API methods in this topic.

Editor Dialog

Smart.Editor uses a Smart.Window component as a dialog for inserting/editing hyperlinks/tables/images and videos. The Dialog is triggered from the corresponding toolbar item or the context menu. Editor dialogs are very specific so we will cover them one by one in this topic.

The following dialog windows are used by the Smart.Editor:

Editor dialogs contain input fields, checkboxes and other controls that allow to configure the element before submiting the window.

Editor Dialogs can contain different fields depending on the editMode as well. Whether it's set to markdown or html, the corresponding output will be generated when the Dialog is submited.

Editor dialog content can be customized via the windowCustomizationFunction property.

Editor Image Dialog

The Image Dialog allows to insert/edit an image into the Editor. The image can be uploaded from the local machine or embeded via an external url address.

HTML Edit Mode Image Dialog

Contains the following fields:

  • file - a Smart.FileUpload control that allows to select an image file to upload to the Editor.
  • url - an alternative url field for the image if a local file is not selected.
  • width - the width of the image.
  • height - the height of the image.
  • alt - an alternative text that will appear instead of the image if the image is not loaded successfully.
  • title - the title that will be displayed when the image is hovered.
  • caption - a caption that will appear under the image , if set.
  • display - a display setting for the image which determines whether to display the image as a block or inline element.
  • alignment - determines whether to align the image to the left, center or right position.
  • draggable - determines whether the image is draggable or not.
  • resizable - determines whether the image is resizable or not.

Markdown Edit Mode Image Dialog

Contains the following fields:

  • file - a Smart.FileUpload control that allows to select an image file to upload to the Editor.
  • url - an alternative url field for the image if a local file is not selected.
  • alt - an alternative text that will appear instead of the image if the image is not loaded successfully.
  • title - the title that will be displayed when the image is hovered.

Editor Video Dialog

The Video dialog allows to insert/edit videos in the Editor. The video can be uploaded from local storage or a YouTube embeded video.

When inserting an embeded video from YouTube, the user has to set the proper link to a YouTube embeded video.

When a video is inserted from local storage, an HTML5 Video element is created to display the video.

Whe an embeded via is used instead, an iframe is used to display the video.

Markdown does not support video playback. So when inserting a video in markdown edit mode, it is represented as a thumbnail image with a hyperlink that points to an external address where the video can be presented.

HTML Edit Mode Video Dialog

Contains the following fields:

  • file - a Smart.FileUpload control that allows to select a video ( the supported video file formats are: .mp4, .webM, .avi, .ogg, .ogv) file to upload to the Editor.
  • src - an alternative source to a YouTube embed video.
  • width - the width for the video. By default YouTube recommends 16:9 aspect ratio of minimum 480px.
  • height - the height for the video. By default YouTube recommends 16:9 aspect radio of minimum 270px.
  • title - a title for the video that is displayed when hovered.
  • caption - a caption for the video that is displayed below.
  • display - determines whether to display the video as a block or an inline element.
  • alignment - determines whether to align the video to the left, center or right position.
  • resizable - determines whether the video is resizable or not.

Markdown Edit Mode Video Dialog

Contains the following fields:

  • file - a Smart.FileUpload control that allows to select a thumbnail image for the video from local storage.
  • thumbnail - a url address to an external image that can be used as a thumbnail for the video.
  • videoUrl - a url address for the video.
  • alt - an alternative text to be displayed if no thumbnail is provided.
  • title - a title for the video when it is hovered.

Editor Table Dialog

The Table Dialog allows to insert/edit tables inside the Editor.

HTML Edit Mode Table Dialog

Contains the following fields:

  • cols - the number of columns the Table will have.
  • rows - the number of rows the Table will have.
  • width - the width of the Table.
  • height - the height of the Table.
  • tableheader - determines whether the Table will have a header or not.
  • altrrows - determines whether the Table will have alternated rows or not.
  • dashedborders - determines whether the Table will have dashed borders or not.
  • resizable - determines whether resizing of the Table is allowed or not.

Markdown Edit Mode Table Dialog

Contains the following fields:

  • cols - the number of columns the Table will have.
  • rows - the number of rows the Table will have.
  • tableheader - determines whether the Table will have a header or not.

Customizing Editor Dialogs

All Editor Dialogs use the same Smart.Window element. Only the controls inside the dialog differ. They depend on the toolbar item that is clicked or the currently active element inside the Editor.

The content of the Dialogs can be completely customized via the windowCustomizationFunction property. It represents a function that accepts to arguments:

  • popupWindow - a reference to the dialog element.
  • item - the toolbar item that corresponds to the action.

Example usage:

componentRef.current.windowCustomizationFunction = function (target, item) {
    if(item.name === 'image') {
        target.innerHTML = 'New HTML Content for the Image Dialog';
    }
    else {
        target.innerHTML = '';
    }
}
For AI tooling

Developer Quick Reference

Topic: editor-dialogs   Component: Editor   Framework: React

Main methods: (none detected)

Common config keys: (none detected)

Implementation Notes

Compatibility: React 19+   API access pattern: const componentRef = useRef(null) + componentRef.current.method()

Lifecycle guidance: Use useMemo for large config objects and call imperative API through componentRef.current after first render.

Common pitfalls:

  • Recreating columns/dataSource objects on every render can reset component state.
  • Calling API methods before ref is available causes runtime errors.
  • Mixing controlled and imperative updates without sync can lead to stale UI.

Validation checklist:

  • Keep config objects memoized when possible.
  • Guard API calls with ref existence checks.
  • Verify CSS theme import is present once per app.

Smart.Editor Dialogs

Editor for Angular

Angular standalone version of this topic (compatible with Angular 17+). Import both the Smart UI component and module in the standalone component.

What this topic covers: practical setup, the framework-specific API access pattern, and copy-adapt guidance for the examples in this page.

import { Component, ViewChild, ViewEncapsulation } from '@angular/core';
import { CommonModule } from '@angular/common';
import { RouterOutlet } from '@angular/router';
import { EditorComponent, EditorModule } from 'smart-webcomponents-angular/editor';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [CommonModule, EditorModule, RouterOutlet],
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.css'],
  encapsulation: ViewEncapsulation.None
})
export class AppComponent {
  @ViewChild('editor', { read: EditorComponent, static: false }) editor!: EditorComponent;
}
<!-- app.component.html -->
<smart-editor #editor></smart-editor>

Use this.editor for API methods in this topic.

Editor Dialog

Smart.Editor uses a Smart.Window component as a dialog for inserting/editing hyperlinks/tables/images and videos. The Dialog is triggered from the corresponding toolbar item or the context menu. Editor dialogs are very specific so we will cover them one by one in this topic.

The following dialog windows are used by the Smart.Editor:

Editor dialogs contain input fields, checkboxes and other controls that allow to configure the element before submiting the window.

Editor Dialogs can contain different fields depending on the editMode as well. Whether it's set to markdown or html, the corresponding output will be generated when the Dialog is submited.

Editor dialog content can be customized via the windowCustomizationFunction property.

Editor Image Dialog

The Image Dialog allows to insert/edit an image into the Editor. The image can be uploaded from the local machine or embeded via an external url address.

HTML Edit Mode Image Dialog

Contains the following fields:

  • file - a Smart.FileUpload control that allows to select an image file to upload to the Editor.
  • url - an alternative url field for the image if a local file is not selected.
  • width - the width of the image.
  • height - the height of the image.
  • alt - an alternative text that will appear instead of the image if the image is not loaded successfully.
  • title - the title that will be displayed when the image is hovered.
  • caption - a caption that will appear under the image , if set.
  • display - a display setting for the image which determines whether to display the image as a block or inline element.
  • alignment - determines whether to align the image to the left, center or right position.
  • draggable - determines whether the image is draggable or not.
  • resizable - determines whether the image is resizable or not.

Markdown Edit Mode Image Dialog

Contains the following fields:

  • file - a Smart.FileUpload control that allows to select an image file to upload to the Editor.
  • url - an alternative url field for the image if a local file is not selected.
  • alt - an alternative text that will appear instead of the image if the image is not loaded successfully.
  • title - the title that will be displayed when the image is hovered.

Editor Video Dialog

The Video dialog allows to insert/edit videos in the Editor. The video can be uploaded from local storage or a YouTube embeded video.

When inserting an embeded video from YouTube, the user has to set the proper link to a YouTube embeded video.

When a video is inserted from local storage, an HTML5 Video element is created to display the video.

Whe an embeded via is used instead, an iframe is used to display the video.

Markdown does not support video playback. So when inserting a video in markdown edit mode, it is represented as a thumbnail image with a hyperlink that points to an external address where the video can be presented.

HTML Edit Mode Video Dialog

Contains the following fields:

  • file - a Smart.FileUpload control that allows to select a video ( the supported video file formats are: .mp4, .webM, .avi, .ogg, .ogv) file to upload to the Editor.
  • src - an alternative source to a YouTube embed video.
  • width - the width for the video. By default YouTube recommends 16:9 aspect ratio of minimum 480px.
  • height - the height for the video. By default YouTube recommends 16:9 aspect radio of minimum 270px.
  • title - a title for the video that is displayed when hovered.
  • caption - a caption for the video that is displayed below.
  • display - determines whether to display the video as a block or an inline element.
  • alignment - determines whether to align the video to the left, center or right position.
  • resizable - determines whether the video is resizable or not.

Markdown Edit Mode Video Dialog

Contains the following fields:

  • file - a Smart.FileUpload control that allows to select a thumbnail image for the video from local storage.
  • thumbnail - a url address to an external image that can be used as a thumbnail for the video.
  • videoUrl - a url address for the video.
  • alt - an alternative text to be displayed if no thumbnail is provided.
  • title - a title for the video when it is hovered.

Editor Table Dialog

The Table Dialog allows to insert/edit tables inside the Editor.

HTML Edit Mode Table Dialog

Contains the following fields:

  • cols - the number of columns the Table will have.
  • rows - the number of rows the Table will have.
  • width - the width of the Table.
  • height - the height of the Table.
  • tableheader - determines whether the Table will have a header or not.
  • altrrows - determines whether the Table will have alternated rows or not.
  • dashedborders - determines whether the Table will have dashed borders or not.
  • resizable - determines whether resizing of the Table is allowed or not.

Markdown Edit Mode Table Dialog

Contains the following fields:

  • cols - the number of columns the Table will have.
  • rows - the number of rows the Table will have.
  • tableheader - determines whether the Table will have a header or not.

Customizing Editor Dialogs

All Editor Dialogs use the same Smart.Window element. Only the controls inside the dialog differ. They depend on the toolbar item that is clicked or the currently active element inside the Editor.

The content of the Dialogs can be completely customized via the windowCustomizationFunction property. It represents a function that accepts to arguments:

  • popupWindow - a reference to the dialog element.
  • item - the toolbar item that corresponds to the action.

Example usage:

this.editor.windowCustomizationFunction = function (target, item) {
    if(item.name === 'image') {
        target.innerHTML = 'New HTML Content for the Image Dialog';
    }
    else {
        target.innerHTML = '';
    }
}
For AI tooling

Developer Quick Reference

Topic: editor-dialogs   Component: Editor   Framework: Angular

Main methods: (none detected)

Common config keys: (none detected)

Implementation Notes

Compatibility: Angular 17+ (standalone)   API access pattern: @ViewChild(...) + this.component.method()

Lifecycle guidance: Bind inputs declaratively and call imperative API through @ViewChild in/after ngAfterViewInit.

Common pitfalls:

  • Using @ViewChild API too early (before view init).
  • Omitting standalone imports for Smart modules in @Component.imports.
  • Type mismatches between configuration fields and template bindings.

Validation checklist:

  • Ensure module import exists in standalone component imports array.
  • Use typed @ViewChild(..., { read: ComponentType }).
  • Call imperative methods after view initialization.

Smart.Editor Dialogs

Editor for Vue

Vue 3 version using Smart custom elements and template refs.

What this topic covers: practical setup, the framework-specific API access pattern, and copy-adapt guidance for the examples in this page.

<script setup>
import { onMounted, ref } from 'vue';
import 'smart-webcomponents/source/styles/smart.default.css';
import 'smart-webcomponents/source/modules/smart.editor.js';

const component = ref();
const componentProps = {
  // Copy this topic's JavaScript configuration here.
};

onMounted(() => {
  Object.assign(component.value, componentProps);
});
</script>

<template>
  <smart-editor ref="component"></smart-editor>
</template>

Use component.value for API methods in this topic.

Editor Dialog

Smart.Editor uses a Smart.Window component as a dialog for inserting/editing hyperlinks/tables/images and videos. The Dialog is triggered from the corresponding toolbar item or the context menu. Editor dialogs are very specific so we will cover them one by one in this topic.

The following dialog windows are used by the Smart.Editor:

Editor dialogs contain input fields, checkboxes and other controls that allow to configure the element before submiting the window.

Editor Dialogs can contain different fields depending on the editMode as well. Whether it's set to markdown or html, the corresponding output will be generated when the Dialog is submited.

Editor dialog content can be customized via the windowCustomizationFunction property.

Editor Image Dialog

The Image Dialog allows to insert/edit an image into the Editor. The image can be uploaded from the local machine or embeded via an external url address.

HTML Edit Mode Image Dialog

Contains the following fields:

  • file - a Smart.FileUpload control that allows to select an image file to upload to the Editor.
  • url - an alternative url field for the image if a local file is not selected.
  • width - the width of the image.
  • height - the height of the image.
  • alt - an alternative text that will appear instead of the image if the image is not loaded successfully.
  • title - the title that will be displayed when the image is hovered.
  • caption - a caption that will appear under the image , if set.
  • display - a display setting for the image which determines whether to display the image as a block or inline element.
  • alignment - determines whether to align the image to the left, center or right position.
  • draggable - determines whether the image is draggable or not.
  • resizable - determines whether the image is resizable or not.

Markdown Edit Mode Image Dialog

Contains the following fields:

  • file - a Smart.FileUpload control that allows to select an image file to upload to the Editor.
  • url - an alternative url field for the image if a local file is not selected.
  • alt - an alternative text that will appear instead of the image if the image is not loaded successfully.
  • title - the title that will be displayed when the image is hovered.

Editor Video Dialog

The Video dialog allows to insert/edit videos in the Editor. The video can be uploaded from local storage or a YouTube embeded video.

When inserting an embeded video from YouTube, the user has to set the proper link to a YouTube embeded video.

When a video is inserted from local storage, an HTML5 Video element is created to display the video.

Whe an embeded via is used instead, an iframe is used to display the video.

Markdown does not support video playback. So when inserting a video in markdown edit mode, it is represented as a thumbnail image with a hyperlink that points to an external address where the video can be presented.

HTML Edit Mode Video Dialog

Contains the following fields:

  • file - a Smart.FileUpload control that allows to select a video ( the supported video file formats are: .mp4, .webM, .avi, .ogg, .ogv) file to upload to the Editor.
  • src - an alternative source to a YouTube embed video.
  • width - the width for the video. By default YouTube recommends 16:9 aspect ratio of minimum 480px.
  • height - the height for the video. By default YouTube recommends 16:9 aspect radio of minimum 270px.
  • title - a title for the video that is displayed when hovered.
  • caption - a caption for the video that is displayed below.
  • display - determines whether to display the video as a block or an inline element.
  • alignment - determines whether to align the video to the left, center or right position.
  • resizable - determines whether the video is resizable or not.

Markdown Edit Mode Video Dialog

Contains the following fields:

  • file - a Smart.FileUpload control that allows to select a thumbnail image for the video from local storage.
  • thumbnail - a url address to an external image that can be used as a thumbnail for the video.
  • videoUrl - a url address for the video.
  • alt - an alternative text to be displayed if no thumbnail is provided.
  • title - a title for the video when it is hovered.

Editor Table Dialog

The Table Dialog allows to insert/edit tables inside the Editor.

HTML Edit Mode Table Dialog

Contains the following fields:

  • cols - the number of columns the Table will have.
  • rows - the number of rows the Table will have.
  • width - the width of the Table.
  • height - the height of the Table.
  • tableheader - determines whether the Table will have a header or not.
  • altrrows - determines whether the Table will have alternated rows or not.
  • dashedborders - determines whether the Table will have dashed borders or not.
  • resizable - determines whether resizing of the Table is allowed or not.

Markdown Edit Mode Table Dialog

Contains the following fields:

  • cols - the number of columns the Table will have.
  • rows - the number of rows the Table will have.
  • tableheader - determines whether the Table will have a header or not.

Customizing Editor Dialogs

All Editor Dialogs use the same Smart.Window element. Only the controls inside the dialog differ. They depend on the toolbar item that is clicked or the currently active element inside the Editor.

The content of the Dialogs can be completely customized via the windowCustomizationFunction property. It represents a function that accepts to arguments:

  • popupWindow - a reference to the dialog element.
  • item - the toolbar item that corresponds to the action.

Example usage:

component.value.windowCustomizationFunction = function (target, item) {
    if(item.name === 'image') {
        target.innerHTML = 'New HTML Content for the Image Dialog';
    }
    else {
        target.innerHTML = '';
    }
}
For AI tooling

Developer Quick Reference

Topic: editor-dialogs   Component: Editor   Framework: Vue

Main methods: (none detected)

Common config keys: (none detected)

Implementation Notes

Compatibility: Vue 3+   API access pattern: const component = ref() + component.value.method()

Lifecycle guidance: Use template refs with